accounts/urls.py
from accounts.views import signup,user_login,user_logout
from django.urls import path


urlpatterns = [
    path('signup/', signup, name="signup"),
    path("login/",user_login, name="user_login"),
    path("logout/", user_logout,name="user_logout")
]

recipes/urls.py
from django.urls import path
from recipes.views import show_recipe, recipe_list,create_recipe,edit_recipe,my_recipe_list,add_steps, add_ingredients, delete_recipe


urlpatterns = [
    path('recipes/<int:id>/', show_recipe, name="show_recipe"),
    path("recipes/",recipe_list, name ="recipe_list"),
    path("recipes/create/", create_recipe, name="create_recipe"),
    path("recipes/<int:id>/edit/", edit_recipe, name ="edit_recipe"),
    path("mine/",my_recipe_list, name="my_recipe_list"),
    path("recipes/add_steps/<int:id>", add_steps, name="add_steps"),
    path("recipes/ingredients/", add_ingredients, name="add_ingredients"),
    path("recipes/delete/<int:id>", delete_recipe, name="delete_recipe"),


]

scrumptious/urls.py
from django.contrib import admin
from django.urls import path, include
from django.shortcuts import redirect




def redirect_to_recipe_list(request):
    return redirect("recipe_list")



urlpatterns = [
    path("", redirect_to_recipe_list, name="list.html"),
    path('admin/', admin.site.urls),
    path("", include("recipes.urls")),
    path("accounts/",include("accounts.urls")),
 ]

accounts/models.py
from django.db import models

# Create your models here.

recipes/models.py
from django.db import models
from django.conf import settings

# Create your models here.


class Recipe(models.Model):
    title = models.CharField(max_length=200)
    picture = models.URLField()
    description=models.TextField()
    created_on=models.DateTimeField(auto_now_add=True)
    rating=models.FloatField(null=True)


    author = models.ForeignKey(
        settings.AUTH_USER_MODEL,
        related_name="recipes",
        on_delete=models.CASCADE,
        null=True,
    )

    def __str__(self):
        return self.title
    
   

 

class RecipeStep(models.Model):
    step_number=models.PositiveSmallIntegerField()
    instruction=models.TextField()
    recipe=models.ForeignKey(Recipe,related_name="steps",on_delete=models.CASCADE)

    class Meta:
        ordering=["step_number"]


class Ingredients(models.Model):
    amount=models.CharField(max_length=100)
    food_item=models.CharField(max_length=100)
    recipe=models.ForeignKey(Recipe, related_name="ingredients",on_delete=models.CASCADE)

    class Meta:
        ordering=["food_item"]

accounts/forms.py
from django import forms



class SignUpForm(forms.Form):
    username=forms.CharField(max_length=150)
    password=forms.CharField(max_length=150,widget=forms.PasswordInput)
    password_confirmation=forms.CharField(max_length=150,widget=forms.PasswordInput)



class LoginForm(forms.Form):
    username=forms.CharField(max_length=100)
    password=forms.CharField(max_length=100,widget=forms.PasswordInput)

recipes/forms.py
from django.forms import ModelForm
from recipes.models import Recipe, RecipeStep, Ingredients


class RecipeForm(ModelForm):
    class Meta:
        model=Recipe
        fields=[
            "title",
            "picture",
            "description",
            "rating"
        ]

class EditRecipeForm(ModelForm):
    class Meta:
        model=Recipe
        fields=[
            "title",
            "picture",
            "description",
            "rating"
        ]

class EditStepsForm(ModelForm):
    class Meta:
        model=RecipeStep
        fields=[
            "step_number",
            "instruction",
            "recipe"
        ]

class EditIngredientForm(ModelForm):
    class Meta:
        model = Ingredients
        fields =[
            "amount",
            "food_item",
            "recipe"
        ]

accounts/views.py
from django.shortcuts import render,redirect
from accounts.forms import SignUpForm,LoginForm
from django.contrib.auth.models import User
from django.contrib.auth import login,authenticate,logout

# Create your views here.


def signup(request):
    if request.method == "POST":
        form =SignUpForm(request.POST)
        if form.is_valid():
            username=form.cleaned_data["username"]
            password=form.cleaned_data["password"]
            password_confirmation=form.cleaned_data["password_confirmation"]

            if password == password_confirmation:
                user = User.objects.create_user(username, password) 
                login(request,user)

                return redirect("recipe_list")
            else:
                form.add_error("password","Passwords do not match")
    else:
        form=SignUpForm()
        context={
            "form":form
        }
    return render(request,"accounts/signup.html", context)



def user_login(request):
    if request.method=="POST":
        form =LoginForm(request.POST)
        if form.is_valid():
            username=request.POST["username"]
            password=request.POST["password"]
            user=authenticate(request,username=username,password=password)

            if user is not None:
                login(request,user)
                return redirect("recipe_list")
    else:
        form = LoginForm()
    context={
        "form":form
    }
    return render(request, "accounts/login.html",context )      

def user_logout(request):
    logout(request)
    return redirect("recipe_list")

recipes/views.py
from django.shortcuts import render , get_object_or_404, get_list_or_404, redirect
from django.http import HttpResponse
from recipes.models import Recipe, RecipeStep, Ingredients
from recipes.forms import RecipeForm,EditRecipeForm, EditStepsForm, EditIngredientForm
from django.contrib.auth.decorators import login_required

# Create your views here.

# watch indentation 

@login_required
def create_recipe(request):
    if request.method=="POST":
        print(request.POST)
        form = RecipeForm(request.POST)
        if form.is_valid():
            print(form)
            recipe=form.save(False)
            recipe.author=request.user
            form.save()
            return redirect("recipe_list")
    else:
        form =RecipeForm()
    context={
        "form":form
            }
    return render(request,"recipes/create.html",context)


def delete_recipe(request, id):
  list = get_object_or_404(Recipe.objects, id=id)
  if request.method == "POST":
    list.delete()
    return redirect("recipe_list")

  return render(request, "recipes/recipe_delete.html")



def edit_recipe(request,id):
    post =get_object_or_404(Recipe.objects,id=id)
    if request.method == "POST":
        form = EditRecipeForm(request.POST, instance=post)
        if form.is_valid():
            form.save()
            return redirect("show_recipe",id=id)
    else:
        form =EditRecipeForm(instance=post)

    context={
        "post_object":post,
        "post_form":form,
    }
    return render(request, "recipes/edit.html",context)


def add_steps(request,id):
    recipes = Recipe.objects.filter(id=id)
    if request.method=="POST":
        print(request.POST)
        form = EditStepsForm(request.POST)
        if form.is_valid():
            recipe=form.save(False)
            recipe.author=request.user
            form.save()
            return redirect("recipe_list")
    else:
        form =EditStepsForm()
    context={
        "recipes":recipes,
        "form":form
        }
    return render(request,"recipes/add_steps.html",context)


def add_ingredients(request):
    if request.method=="POST":
        form = EditIngredientForm(request.POST)
        if form.is_valid():
            recipe=form.save(False)
            recipe.author=request.user
            form.save()
            return redirect("recipe_list")
    else:
        form =EditIngredientForm()
    context={
        "form":form
        }
    return render(request,"recipes/add_ingredients.html",context)


def show_recipe(request,id):
    # recipe=Recipe.objects.get(id=id)
    recipe=get_object_or_404(Recipe.objects,id=id)
    context={
        "recipe_object":recipe
    }
    return render(request, "recipes/detail.html", context)

def recipe_list(request):
    recipes= get_list_or_404(Recipe.objects.all())
    context={
        "recipe_list":recipes
    }
    return render(request , "recipes/list.html", context)

@login_required
def my_recipe_list(request):
    recipes = Recipe.objects.filter(author=request.user)
    context = {
        "recipe_list": recipes,
    }
    return render(request, "recipes/mine.html", context)

accounts/templates/accounts/login.html
{% extends 'base.html' %}

{% block title %}
Sign Up! - Scrumptious Recipes
{% endblock title %}

{% block content %}

<header>
  <nav class="navbar navbar-expand-lg bg-primary" data-bs-theme="dark">
    <div class="container-fluid">
      <a class="navbar-brand" href="#">Navbar</a>
      <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarColor01" aria-controls="navbarColor01" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>
      <div class="collapse navbar-collapse" id="navbarColor01">
        <ul class="navbar-nav me-auto">
          {% if user.is_authenticated %}
          <li class = "nav-link" > Hello, {{user.username}} </li>
          <li class="nav-item active">
            <a class="nav-link active" href="{% url 'recipe_list' %}">Home</a>
          </li>
          <li>
            <a class="nav-link" href="{% url "user_logout" %}"> Log out </a>
          </li>
            {% else %}
          <li class="nav-item active">
            <a class="nav-link active" href="{% url 'recipe_list' %}">Home</a>
          </li>
          <li>
            <a class="nav-link" href="{% url "signup" %}"> Sign up </a>
          </li>
          {% endif %}
        </ul>
      </div>
    </div>
  </nav>

</header>
<main>
  <h1>Log in!</h1>
  <form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button>Log in</button>
  </form>
</main>
{% endblock content %}

accounts/templates/accounts/signup.html
{% extends 'base.html' %}

{% block title %}
Sign Up! - Scrumptious Recipes
{% endblock title %}

{% block content %}
<header>

  <nav class="navbar navbar-expand-lg bg-primary" data-bs-theme="dark">
    <div class="container-fluid">
      <a class="navbar-brand" href="#">Navbar</a>
      <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarColor01" aria-controls="navbarColor01" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>
      <div class="collapse navbar-collapse" id="navbarColor01">
        <ul class="navbar-nav me-auto">
          {% if user.is_authenticated %}
          <li class = "nav-link" > Hello, {{user.username}} </li>
          <li class="nav-item active">
            <a class="nav-link active" href="{% url 'recipe_list' %}">Home</a>
          </li>
          <li>
            <a class="nav-link" href="{% url "user_logout" %}"> Log out </a>
          </li>
            {% else %}
          <li class="nav-item active">
            <a class="nav-link active" href="{% url 'recipe_list' %}">Home</a>
          </li>
          <li>
            <a class="nav-link" href="{% url "user_login" %}"> Log in </a>
          </li>

          {% endif %}
        </ul>
      </div>
    </div>
  </nav>

</header>
<main>
  <h1>Sign up!</h1>
  <form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button>Sign up</button>
  </form>
</main>
{% endblock content %}

recipes/templates/base.html
{% load static %}


<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>{% block title %} {%endblock title%} </title>
    <link rel="stylesheet" href="{% static "css/recipes.css" %}"/>
    <link rel="stylesheet" href="{% static "css/bootstrap.css" %}"/>

</head>


<body>
    {% block content%} {%endblock content%}

    <footer>Made with love by Scrumptious Recipes</footer>
</body>
</html>

recipes/templates/recipes/add_ingredients.html
{%extends "base.html"%}
{% load static %}


{%block title%}
Scrumptious Recipes
{%endblock title%}

{%block content%}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>{{ recipe_object.title }} -Scrumptious Recipes</title>
    <link rel="stylesheet" href="{% static "css/recipes.css" %}">
</head>
<body>
    <header>

        <nav class="navbar navbar-expand-lg bg-primary" data-bs-theme="dark">
            <div class="container-fluid">
              <a class="navbar-brand" href="#">Navbar</a>
              <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarColor01" aria-controls="navbarColor01" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
              </button>
              <div class="collapse navbar-collapse" id="navbarColor01">
                <ul class="navbar-nav me-auto">
                  {% if user.is_authenticated %}
                  <li class="nav-item active">
                    <a class="nav-link active" href="{% url 'recipe_list' %}">Home</a>
                  </li>
                    <a class="nav-link" href="{% url "user_logout" %}"> Log out </a>
                  </li>
                    {% else %}
                  <li class="nav-item active">
                    <a class="nav-link active" href="{% url 'recipe_list' %}">Home</a>
                  </li>
                  <li>
                  {% endif %}
                </ul>
              </div>
            </div>
          </nav>

    </header>
    <main>

          <form class="main-form" method="POST">
            {% csrf_token %}
                  <fieldset>
                    {{recipes.title}}
                    <div class="form-group row">
                    </div>
                    <div class="form-group">
                      <label for="exampleInputEmail1"  class="form-label mt-4">Amount</label>
                      <input type="text" name="amount"  maxlength="200" required id="id_amount" class="form-control"aria-describedby="emailHelp">
                      <small id="emailHelp" class="form-text text-muted">Enter The Amount</small>
                    </div>
                    <div class="form-group">
                      <label for="exampleInputPassword1" class="form-label mt-4">Ingredient</label>
                      <input type="text" class="form-control" name="food_item" maxlength="200" required id="id_food_item" autocomplete="off">
                      <small id="emailHelp" class="form-text text-muted">Enter The Amount of Ingredient</small>

                    </div>

                    <div class="form-group">
                      <div class="dropdown">
                        <button class="btn btn-lg btn-primary null">Choose Recipe</button>  
                          <div>
                          {{form.recipe}}
                        </div>
                      </div>
                      </div>
                      

                    <div class="form-group">
                      <button class="btn btn-primary"> Add Ingredient </button>
                    </div>
                </form>

    </main>
    {%endblock%}
    <footer>
        Made with love by Scrumptious Recipes
    </footer> 
</body>
</html>

recipes/templates/recipes/add_steps.html
{%extends "base.html"%}
{% load static %}


{%block title%}
Scrumptious Recipes
{%endblock title%}

{%block content%}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>{{ recipe_object.title }} -Scrumptious Recipes</title>
    <link rel="stylesheet" href="{% static "css/recipes.css" %}">
</head>
<body>
    <header>

        <nav class="navbar navbar-expand-lg bg-primary" data-bs-theme="dark">
            <div class="container-fluid">
              <a class="navbar-brand" href="#">Navbar</a>
              <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarColor01" aria-controls="navbarColor01" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
              </button>
              <div class="collapse navbar-collapse" id="navbarColor01">
                <ul class="navbar-nav me-auto">
                  {% if user.is_authenticated %}
                  <li class="nav-item active">
                    <a class="nav-link active" href="{% url 'recipe_list' %}">Home</a>
                  </li>
                    <a class="nav-link" href="{% url "user_logout" %}"> Log out </a>
                  </li>
                    {% else %}
                  <li class="nav-item active">
                    <a class="nav-link active" href="{% url 'recipe_list' %}">Home</a>
                  </li>
                  <li>
                  {% endif %}
                </ul>
              </div>
            </div>
          </nav>

    </header>
    <main>


          <form class="main-form" method="POST">
            {% csrf_token %}
                  <fieldset>
                    {{recipes.title}}
                    <div class="form-group row">
                    </div>
                    <div class="form-group">
                      <label for="exampleInputEmail1"  class="form-label mt-4">Step Number</label>
                      <input type="number" name="step_number"  maxlength="200" required id="id_step_number" class="form-control"aria-describedby="emailHelp">
                      <small id="emailHelp" class="form-text text-muted">Enter The Step Number</small>
                    </div>
                    <div class="form-group">
                      <label for="exampleInputPassword1" class="form-label mt-4">Instruction</label>
                      <input type="text" class="form-control" name="instruction" maxlength="200" required id="id_instruction" autocomplete="off">
                      <small id="emailHelp" class="form-text text-muted">Enter The Instruction</small>

                    </div>

                    <div class="form-group">
                      <div class="dropdown">
                        <button class="btn btn-lg btn-primary null">Choose Recipe</button>  
                          <div>
                          {{form.recipe}}
                        </div>
                      </div>
                      </div>
                      

                    <div class="form-group">
                      <button class="btn btn-primary"> Add Step </button>
                    </div>
                </form>

                
    </main>
    {%endblock%}   
    <footer>
        Made with love by Scrumptious Recipes
    </footer> 


</body>

</html>

recipes/templates/recipes/create.html
{%extends "base.html"%}
{% load static%}



{%block title%}
Scrumptious Recipe
{%endblock title%}


{%block content%} 


<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>{{ recipe_object.title }} -Scrumptious Recipes</title>
    <link rel="stylesheet" href="{% static "css/recipes.css" %}">
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-lg bg-primary" data-bs-theme="dark">
            <div class="container-fluid">
              <a class="navbar-brand" href="#">Navbar</a>
              <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarColor01" aria-controls="navbarColor01" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
              </button>
              <div class="collapse navbar-collapse" id="navbarColor01">
                <ul class="navbar-nav me-auto">
                  {% if user.is_authenticated %}
                  <li class="nav-item active">
                    <a class="nav-link active" href="{% url 'recipe_list' %}">Home</a>
                  </li>
                  <li>
                    <a class="nav-link" href="{% url "user_logout" %}"> Log out </a>
                  </li>
                    {% else %}
                  <li class="nav-item active">
                    <a class="nav-link active" href="{% url 'recipe_list' %}">Home</a>
                  </li>
                  <li>
                    <a class="nav-link" href="{% url "signup" %}"> Sign up </a>
                  </li>
                  <li>
                    <a class="nav-link" href="{% url "user_login" %}"> Log in </a>
                  </li>
                  <li class="nav-item">
                    <a class="nav-link" href="#">About</a>
                  </li>
                  {% endif %}
                </ul>
              </div>
            </div>
          </nav>
          
    </header>
    <main>
     <form class="main-form" method="POST">
      {% csrf_token %}
            <fieldset>
              <div class="form-group row">
              </div>
              <div class="form-group">
                <label for="exampleInputEmail1"  class="form-label mt-4">Recipe Name</label>
                <input type="text" name="title"  maxlength="200" required id="id_title" class="form-control" aria-describedby="emailHelp">
                <small id="emailHelp" class="form-text text-muted">Enter your recipe name</small>
              </div>
              <div class="form-group">
                <label for="exampleInputPassword1" class="form-label mt-4">Image</label>
                <input type="text" class="form-control" name="picture" maxlength="200" required id="id_picture" placeholder="Image URL" autocomplete="off">
              </div>
              <div class="form-group">
                <label for="exampleTextarea" class="form-label mt-4">Description</label>
                <textarea class="form-control" name="description" cols="40" rows="10" required id="id_description" rows="3"></textarea>
              </div>

              <div class="form-group">
                <label for="exampleInputPassword1" class="form-label mt-4">Rating</label>
                <input class="form-control" type="number" name="rating" value="3" step="any" required id="id_rating" autocomplete="off">
              </div>

                <button class="btn btn-primary"> Create </button>
          </form>

    </main> 
    {%endblock%}
    <footer>
        Made with love by Scrumptious Recipes
    </footer> 
</body>
</html>

recipes/templates/recipes/detail.html
{%extends "base.html"%}
{% load static%}



{%block title%}
Scrumptious Recipe
{%endblock title%}


{%block content%} 

<body>
    <header>

        
  <nav class="navbar navbar-expand-lg bg-primary" data-bs-theme="dark">
    <div class="container-fluid">
      <a class="navbar-brand" href="#">Navbar</a>
      <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarColor01" aria-controls="navbarColor01" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>
      <div class="collapse navbar-collapse" id="navbarColor01">
        <ul class="navbar-nav me-auto">
          {% if user.is_authenticated %}
          <li class="nav-item active">
            <a class="nav-link active" href="{% url 'recipe_list' %}">Home</a>
          </li>
          <li>
            <a class="nav-link" href="{% url 'edit_recipe' recipe_object.id %}">Edit Recipe</a>
          </li>
          <li>
            <a class="nav-link" href="{% url 'add_steps' recipe_object.id %}">Add Step</a>
          </li>
          <li>
            <a class="nav-link" href="{% url 'add_ingredients' %}">Add ingredient</a>
          </li>
          <li>
            <a class="nav-link" href="{% url "user_logout" %}"> Log out </a>
          </li>
          <li>
           <a class="nav-link" href="{% url 'delete_recipe' recipe_object.id %}"> Delete Recipe </a>
          </li>
            {% else %}
          <li class="nav-item active">
            <a class="nav-link active" href="{% url 'recipe_list' %}">Home</a>
          </li>
          {% endif %}
        </ul>
      </div>
    </div>
  </nav>

    </header>
    <main>
        <div class="recipe-details">
        <h1>{{recipe_object.title}}</h1>
        <img src="{{recipe_object.picture}}">
        <div>{{recipe_object.rating}} Stars</div>
        </div>
        <p>{{recipe_object.description}}</p>
        <h2>Ingredients</h2>
        <table class="table-details">

            <thead>
                <tr>
                    <th>Amount</th>
                    <th>Food item</th>
                </tr>

            <tbody class="items">
                {% for ingredient in recipe_object.ingredients.all %}
                    <tr>
                        <td>{{ingredient.amount}}</td>
                        <td>{{ingredient.food_item}}</td>
                    </tr>
                    {% endfor %}
            </tbody>

            </thead>

        </table>
        <h2>Steps</h2>
        <ol>
            {% for step in recipe_object.steps.all %}
                <li> {{step.instruction}} </li>
                {% endfor %}
        </ol>
    </main>   

</body>
{%endblock content%}
</html>

recipes/templates/recipes/edit.html
{%extends "base.html"%}
{% load static%}



{%block title%}
Scrumptious Recipe
{%endblock title%}


{%block content%} 

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>{{ recipe_object.title }} -Scrumptious Recipes</title>
    <link rel="stylesheet" href="{% static "css/recipes.css" %}">
</head>
<body>
    <header>

        <nav class="navbar navbar-expand-lg bg-primary" data-bs-theme="dark">
            <div class="container-fluid">
              <a class="navbar-brand" href="#">Navbar</a>
              <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarColor01" aria-controls="navbarColor01" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
              </button>
              <div class="collapse navbar-collapse" id="navbarColor01">
                <ul class="navbar-nav me-auto">
                  {% if user.is_authenticated %}
                  <li class="nav-item active">
                    <a class="nav-link active" href="{% url 'recipe_list' %}">Home</a>
                  </li>
                  <li class="nav-item">
                    <a class="nav-link" href="{% url 'create_recipe' %}">Create Recipe</a>
                  </li>
                  <li>
                    <a class="nav-link" href="{% url "user_logout" %}"> Log out </a>
                  </li>
                    {% else %}
                  <li class="nav-item active">
                    <a class="nav-link active" href="{% url 'recipe_list' %}">Home</a>
                  </li>
                  <li>
                    <a class="nav-link" href="{% url "signup" %}"> Sign up </a>
                  </li>
                  <li>
                    <a class="nav-link" href="{% url "user_login" %}"> Log in </a>
                  </li>
                  {% endif %}
                </ul>
              </div>
            </div>
          </nav>

    </header>
    <main>
        <h1>Edit {{ post_object.title }}</h1>
        <form class="main-form" method="POST">
          {% csrf_token %}
                <fieldset>
                  <div class="form-group row">
                  </div>
                  <div class="form-group">
                    <label for="exampleInputEmail1"  class="form-label mt-4">Recipe Name</label>
                    <input type="text" name="title"  maxlength="200" required id="id_title" class="form-control" placeholder={{post_object.title}} aria-describedby="emailHelp">
                    <small id="emailHelp" class="form-text text-muted">Enter your recipe name</small>
                  </div>
                  <div class="form-group">
                    <label for="exampleInputPassword1" class="form-label mt-4">Image</label>
                    <input type="text" class="form-control" name="picture" maxlength="200" required id="id_picture" placeholder={{post_object.picture}} autocomplete="off">
                  </div>
                  <div class="form-group">
                    <label for="exampleTextarea" class="form-label mt-4">Description</label>
                    <textarea class="form-control" name="description" cols="40" rows="10" required id="id_description" placeholder={{post_object.description}} rows="3"></textarea>
                  </div>
    
                  <div class="form-group">
                    <label for="exampleInputPassword1" class="form-label mt-4">Rating</label>
                    <input class="form-control" type="number" name="rating" step="any" required id="id_rating" placeholder={{post_object.rating}} autocomplete="off">
                  </div>
                    <button class="btn btn-primary"> Update Recipe </button>
              </form>
    </main>
    {%endblock%}
    <footer>
        Made with love by Scrumptious Recipes
    </footer> 
</body>
</html>

recipes/templates/recipes/mine.html
{%extends "base.html"%}
{% load static %}


{%block title%}
Scrumptious Recipes
{%endblock title%}

{%block content%}
    <header>

      <nav class="navbar navbar-expand-lg bg-primary" data-bs-theme="dark">
        <div class="container-fluid">
          <a class="navbar-brand" href="#">Navbar</a>
          <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarColor01" aria-controls="navbarColor01" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
          </button>
          <div class="collapse navbar-collapse" id="navbarColor01">
            <ul class="navbar-nav me-auto">
              {% if user.is_authenticated %}
              <li class="nav-item active">
                <a class="nav-link active" href="{% url 'recipe_list' %}">Home</a>
              </li>
              <li class="nav-item">
                <a class="nav-link" href="{% url "user_logout" %}"> Log out </a>
              </li>
                {% else %}
              <li class="nav-item active">
                <a class="nav-link active" href="{% url 'recipe_list' %}">Home</a>
              </li>
              {% endif %}
            </ul>
          </div>
        </div>
      </nav>
      
    </header>
    <main>
        <h1>Scrumptious Recipes</h1>
        <h2>All The Recipes You've Made</h2>
        <div class="content">
            {% for recipe in recipe_list %}
            <div>
              <h3>
                <a class="text-primary" href="{% url 'show_recipe' recipe.id %}">{{recipe.title}}</a>
              </h3>
              <img src="{{recipe.picture}}">
              <div>{{recipe.rating}} Stars</div>
              <p>{{recipe.created_on|date:"M. dS, Y"}}</p>
            </div>
            {% endfor %}
    </div>

    </main>
{%endblock content%}


</html>
<int:id>